From 572a3fb3260c8e8535844ebe5861d9d50ac42952 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 22 2017 17:21:45 +0000
Subject: [PATCH 758/1001] Protect the edit views to logged-in users only


---

diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
index 2a53ba5..a682d85 100644
--- a/hubs/tests/test_fedora_hubs_flask_api.py
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -214,14 +214,18 @@ class HubsAPITest(hubs.tests.APPTest):
                 "/openidc/Authorization")
 
     def test_hub_add_widget_get_no_args(self):
-        result = self.app.get('/ralph/add', follow_redirects=False)
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            result = self.app.get('/ralph/add', follow_redirects=False)
         self.assertEqual(result.status_code, 400)
         expected_str = 'Invalid position provided'
         self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_hub_add_widget_get_with_args(self):
-        result = self.app.get('/ralph/add?position=right',
-                              follow_redirects=True)
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            result = self.app.get('/ralph/add?position=right',
+                                  follow_redirects=True)
         self.assertEqual(result.status_code, 200)
         expected_str = 'Adding a widget to hub: ralph'
         self.assertIn(expected_str, result.get_data(as_text=True))
@@ -230,14 +234,18 @@ class HubsAPITest(hubs.tests.APPTest):
 
     def test_hub_add_widget_post_no_widget_name(self):
         data = {}
-        result = self.app.post('/ralph/add', data=data, follow_redirects=False)
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            result = self.app.post('/ralph/add', data=data, follow_redirects=False)
         self.assertEqual(result.status_code, 400)
         expected_str = 'Invalid request sent'
         self.assertIn(expected_str, result.get_data(as_text=True))
 
     def test_hub_add_widget_post_invalid_widget_name(self):
         data = {'widget_name': 'invalid_widget_name'}
-        result = self.app.post('/ralph/add', data=data, follow_redirects=False)
+        user = tests.FakeAuthorization('ralph')
+        with tests.auth_set(app, user):
+            result = self.app.post('/ralph/add', data=data, follow_redirects=False)
         self.assertEqual(result.status_code, 404)
         expected_str = 'Unknown widget called'
         self.assertIn(expected_str, result.get_data(as_text=True))
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index 3da39d3..a0247f4 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -5,7 +5,7 @@ import flask
 import hubs.models
 
 from hubs.app import app, session
-from .utils import get_hub
+from .utils import get_hub, login_required
 
 
 @app.route('/<name>')
@@ -25,8 +25,8 @@ def hub_json(name):
     return response
 
 
-@app.route('/<name>/edit/', methods=['GET', 'POST'])
 @app.route('/<name>/edit', methods=['GET', 'POST'])
+@login_required
 def hub_edit(name):
     if flask.request.method == 'POST':
         return hub_edit_post(name)
diff --git a/hubs/views/root.py b/hubs/views/root.py
index 6b9102f..386f233 100644
--- a/hubs/views/root.py
+++ b/hubs/views/root.py
@@ -50,6 +50,7 @@ def login():
 
     hubs.models.User.get_or_create(
         flask.g.db, username=flask.g.auth.nickname, fullname=flask.g.auth.fullname)
+    flask.flash('Login successful', 'success')
 
     return flask.redirect(return_point)
 
diff --git a/hubs/views/utils.py b/hubs/views/utils.py
index 94113e3..32b544b 100644
--- a/hubs/views/utils.py
+++ b/hubs/views/utils.py
@@ -52,7 +52,6 @@ def login_required(function):
     def decorated_function(*args, **kwargs):
         """ Decorated function, actually does the work. """
         if not authenticated():
-            flask.flash('Login required', 'errors')
             return flask.redirect(flask.url_for(
                 'login', next=flask.request.url))
 
diff --git a/hubs/views/widget.py b/hubs/views/widget.py
index adc857a..773e357 100644
--- a/hubs/views/widget.py
+++ b/hubs/views/widget.py
@@ -5,7 +5,7 @@ import flask
 
 from hubs.app import app
 from pkg_resources import resource_isdir
-from .utils import get_widget_instance
+from .utils import get_widget_instance, login_required
 
 
 @app.route('/<hub>/<int:idx>/json')
@@ -19,6 +19,7 @@ def widget_json(hub, idx):
 
 @app.route('/<hub>/<int:idx>/edit/', methods=['GET', 'POST'])
 @app.route('/<hub>/<int:idx>/edit', methods=['GET', 'POST'])
+@login_required
 def widget_edit(hub, idx):
     if flask.request.method == 'POST':
         return widget_edit_post(hub, idx)
@@ -71,6 +72,7 @@ def widget_edit_post(hub, idx):
 
 @app.route('/<hub>/<int:idx>/delete/', methods=['POST'])
 @app.route('/<hub>/<int:idx>/delete', methods=['POST'])
+@login_required
 def widget_edit_delete(hub, idx):
     ''' Remove a widget from a hub. '''
     widget = get_widget_instance(hub, idx)

